#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor CVOR;
typedef CVOR* PCVOR;

struct cvor {
	int info;
	PCVOR next;
};

void ubaci_na_pocetak(PCVOR* glava, int broj) {
	PCVOR novi;
	novi = malloc(sizeof(CVOR));
	novi->info = broj;
	novi->next = NULL;

	if (*glava == NULL) {
		*glava = novi;
	}
	else {
		novi->next = *glava;
		*glava = novi;
	}
}

void prikazi_listu(PCVOR glava) {
	PCVOR tekuci;
	tekuci = glava;
	while (tekuci != NULL) {
		printf("%d\t", tekuci->info);
		tekuci = tekuci->next;
	}
}

void ubaci_na_kraj(PCVOR* glava, int broj) {
	PCVOR novi;
	PCVOR poslednji;

	if (*glava == NULL) {
		//lista je prazna
		ubaci_na_pocetak(glava, broj);
	}
	else {
		poslednji = *glava;
		while (poslednji->next != NULL) {
			poslednji = poslednji->next;
		}

		novi = malloc(sizeof(CVOR));
		novi->info = broj;
		novi->next = NULL;
		poslednji->next = novi;
	}
}

int izbaci_sa_kraja(PCVOR* glava) {
	int broj; //broj koji cu da obrisem
	PCVOR brzi, spori;
	brzi = *glava;
	spori = NULL;
	while (brzi->next != NULL) {
		spori = brzi;
		brzi = brzi->next;
	}
	if (spori == NULL) {
		//brisem jedan jedini el u listi
		broj = brzi->info;
		free(brzi);
		*glava = NULL;
	}
	else {
		broj = brzi->info;
		free(brzi);
		spori->next = NULL;
	}
	return broj;
}

int main(void) {
	/*int* pa;
	int a = 10;
	pa = &a;
	printf("\na=%d\n", *pa);
	

	int* pbroj;
	pbroj = malloc(sizeof(int));
	printf("Unesi broj");
	scanf("%d", pbroj);
	printf("\nUneli ste broj %d\n", *pbroj);*/

	PCVOR glava;
	glava = NULL;

	ubaci_na_kraj(&glava, 0);
	ubaci_na_pocetak(&glava, 10);
	ubaci_na_pocetak(&glava, 20);
	ubaci_na_pocetak(&glava, 30);
	ubaci_na_kraj(&glava, 1);
	ubaci_na_kraj(&glava, 2);
	printf("\nElementi liste su ");
	prikazi_listu(glava);

	for (int i = 1; i <= 6; i++) {
		printf("\nObrisan je: %d ", izbaci_sa_kraja(&glava));

		printf("\nElementi liste su ");
		prikazi_listu(glava);
	}
	
	
	ubaci_na_pocetak(&glava, 5);
	printf("\nElementi liste su ");
	prikazi_listu(glava);

	/*PCVOR novi;
	novi = malloc(sizeof(CVOR));
	novi->info = 1;
	novi->next = NULL;

	if (glava == NULL) {
		glava = novi;
	}
	else {
		novi->next = glava;
		glava = novi;
	}*/


	system("pause");
	return 0;
}